.model small

.stack 100h

.data
 Param db 256 dup(0) 
 ParamLength db 0    
 handle dw 0         
 helpMsg db "I duomenu faila irasykite du dvejetainius skaicius atskirtus eilute, paleisdami programa parametruose nurodykite skaiciu failo varda!"
 errorMsg db "Ivyko klaida dirbant su failu!"
 char db 0
 num1 db 1024 dup(0) 
 num2 db 1024 dup(0)
 bits1 dw 0        
 bits2 dw 0
 maxBits dw 0      
 minBits dw 0      
 fname db "rez.txt", 0
 

.code

GetParam: ;procedura nuskaityti parametrams
 mov si, 80h
 mov cx, 0
 mov cl, es:[si]
 mov ParamLength, cl
 cmp cl, 0
 je GetParam_pab      
 lea di, Param
 inc si
 dec cx
 toliau:              
 mov al, es:[si+1]
 mov ds:[di], al
 inc si
 inc di
 loop toliau
 GetParam_pab:
ret 

fopen:
 mov ah, 3Dh           
 mov al, 0             
 mov dx, offset Param  
 int 21h
 mov handle, ax
ret

readChar:
 mov bx, handle      
 mov ah, 3Fh         
 mov cx, 1           
 mov dx, offset char     
 int 21h
 inc si              
 ret

fclose:            
 mov bx, handle
 mov ah, 3Eh
 int 21h
ret

WriteREsults:
 mov ah, 3Ch  
 mov cx, 0  
 mov dx, offset fname
 int 21h
 mov handle, ax
 
 mov bx, handle      
 mov ah, 40h         
 mov cx, maxBits     
 mov dx, si     
 int 21h             
 
 mov bx, handle
 mov ah, 3Eh
 int 21h              
ret

procXOR:
 mov ax, bits1
 mov bx, bits2
 cmp bits1, bx
 jg pirmDidesnis

 mov maxBits, bx  
 mov minBits, ax
 mov si, offset num2
 mov di, offset num1
 jmp testi
 
 pirmDidesnis:     
 mov maxBits, ax
 mov minBits, bx
 mov si, offset num1
 mov di, offset num2

 testi:
 mov ax, maxBits
 sub ax, minBits
 mov cx, minBits

 add si, ax
 mov bx, 0
 vykdyti:         
 mov dh, ds:[di+bx]
 sub dh, 30h
 mov dl, ds:[si+bx]
 sub dl, 30h
 xor dl, dh
 add dl, 30h
 mov ds:[si+bx], dl
 inc bl
 loop vykdyti

 sub si, ax
ret

start:
 mov ax, @data
 mov ds, ax

 call GetParam
 cmp ParamLength, 0      
 je printHelp
 cmp Param[0], "/"
 jne main
 cmp Param[1], "?"
 jne main
 printHelp:
 mov dx, offset helpMsg
 mov bx, 1
 mov ah, 40h
 xor cx, cx
 mov cl, 133              
 int 21h 
 jmp pabaiga

 main:
 call fopen         
 cmp handle, 2
 je FileError

 mov si, 0         
 skaityti1:        
 call readChar
 mov al, char
 mov num1[si-1], al
 cmp char, 13      
 jne skaityti1
 dec si
 mov ax, si
 mov bits1, ax
 call readChar    

 mov si, 0         
 skaityti2:        
 call readChar
 mov bl, char
 mov num2[si-1], bl
 cmp ax, 0      
 jne skaityti2
 dec si
 mov ax, si
 mov bits2, ax

 call procXor    
 call fclose     
 call WriteResults 
 jmp pabaiga

 FileError:
 mov dx, offset errorMsg
 mov bx, 1
 mov ah, 40h
 xor cx, cx
 mov cl, 30              
 int 21h  

 pabaiga:
 mov ah, 4ch
 int 21h
end start